
/**********************************************************************/

/*
interface MPIh
{
}
*/

/**********************************************************************/

class MPIconst
{
MPI_Group	MPI_GROUP_NULL;
MPI_Comm	MPI_COMM_NULL;
MPI_Datatype	MPI_DATATYPE_NULL;
MPI_Request	MPI_REQUEST_NULL;
MPI_Op		MPI_OP_NULL;
/*
MPI_Errhandle	MPI_ERRHANDLER_NULL;
MPI_Copy_function	MPI_NULL_COPY_FN;
MPI_Delete_function	MPI_NULL_DELETE_FN;
*/
ObjectOfJint	MPI_INFO_NULL;


MPI_Comm MPI_COMM_WORLD;
MPI_Comm MPI_COMM_SELF;
MPI_Comm MPI_COMM_PARENT;

MPI_Group MPI_GROUP_EMPTY;

MPI_Op MPI_MAX;
MPI_Op MPI_MIN;
MPI_Op MPI_SUM;
MPI_Op MPI_PROD;
MPI_Op MPI_LAND;
MPI_Op MPI_BAND;
MPI_Op MPI_LOR;
MPI_Op MPI_BOR;
MPI_Op MPI_LXOR;
MPI_Op MPI_BXOR;
MPI_Op MPI_MAXLOC;
MPI_Op MPI_MINLOC;

MPI_Datatype MPI_BYTE;
MPI_Datatype MPI_PACKED;
MPI_Datatype MPI_CHAR;
MPI_Datatype MPI_SHORT;
MPI_Datatype MPI_INT;
MPI_Datatype MPI_LONG;
MPI_Datatype MPI_FLOAT;
MPI_Datatype MPI_DOUBLE;
MPI_Datatype MPI_LONG_DOUBLE;
MPI_Datatype MPI_UNSIGNED_CHAR;
MPI_Datatype MPI_UNSIGNED_SHORT;
MPI_Datatype MPI_UNSIGNED_LONG;
MPI_Datatype MPI_UNSIGNED;
MPI_Datatype MPI_FLOAT_INT;
MPI_Datatype MPI_DOUBLE_INT;
MPI_Datatype MPI_LONG_DOUBLE_INT;
MPI_Datatype MPI_LONG_INT;
MPI_Datatype MPI_SHORT_INT;
MPI_Datatype MPI_2INT;
MPI_Datatype MPI_2FLOAT;
MPI_Datatype MPI_2DOUBLE;
MPI_Datatype MPI_UB;
MPI_Datatype MPI_LB;

MPI_Errhandler MPI_ERRORS_ARE_FATAL;
MPI_Errhandler MPI_ERRORS_RETURN;

int MPI_IDENT;
int MPI_CONGRUENT;
int MPI_SIMILAR;
int MPI_UNEQUAL;

int MPI_ANY_SOURCE;
int MPI_PROC_NULL;
int MPI_CANCEL_SOURCE;
int MPI_ANY_TAG;
int MPI_MAX_PROCESSOR_NAME;
int MPI_MAX_ERROR_STRING;
int MPI_UNDEFINED;
int MPI_CART;
int MPI_GRAPH;
int MPI_KEYVAL_INVALID;
int MPI_TAG_UB;
int MPI_HOST;
int MPI_IO;
int MPI_WTIME_IS_GLOBAL;
int MPI_BOTTOM;
int MPI_BSEND_OVERHEAD;


public native int MPI_Init (ObjectOfJint argc, String argv[]);

public native void create_seq( int key_array[], int MAX_KEY, int NUM_KEYS,
		double seed, double a );

/**********************************************************************/
/*	Get the length of an array - for JDK1.0.2 native methods	*/

public static int	getLength (Object arr[])
{
return arr.length;
}

/**********************************************************************/

static
{
System.loadLibrary("MPI");
// System.load("JavaMPI/libMPI.so");
}

MPIconst ()
{
MPI_GROUP_NULL	= new MPI_Group();
MPI_COMM_NULL	= new MPI_Comm();
MPI_DATATYPE_NULL	= new MPI_Datatype();
MPI_REQUEST_NULL	= new MPI_Request();
MPI_OP_NULL	= new MPI_Op();
/*
MPI_ERRHANDLER_NULL	= new MPI_Errhandle();
MPI_NULL_COPY_FN	= new MPI_Copy_function();
MPI_NULL_DELETE_FN	= new MPI_Delete_function();
*/
MPI_INFO_NULL	= new ObjectOfJint();

MPI_COMM_WORLD	= new MPI_Comm();
MPI_COMM_SELF	= new MPI_Comm();
MPI_COMM_PARENT	= new MPI_Comm();

MPI_GROUP_EMPTY	= new MPI_Group();

MPI_MAX	= new MPI_Op();
MPI_MIN	= new MPI_Op();
MPI_SUM	= new MPI_Op();
MPI_PROD	= new MPI_Op();
MPI_LAND	= new MPI_Op();
MPI_BAND	= new MPI_Op();
MPI_LOR	= new MPI_Op();
MPI_BOR	= new MPI_Op();
MPI_LXOR	= new MPI_Op();
MPI_BXOR	= new MPI_Op();
MPI_MAXLOC	= new MPI_Op();
MPI_MINLOC	= new MPI_Op();

MPI_BYTE	= new MPI_Datatype();
MPI_PACKED	= new MPI_Datatype();
MPI_CHAR	= new MPI_Datatype();
MPI_SHORT	= new MPI_Datatype();
MPI_INT	= new MPI_Datatype();
MPI_LONG	= new MPI_Datatype();
MPI_FLOAT	= new MPI_Datatype();
MPI_DOUBLE	= new MPI_Datatype();
MPI_LONG_DOUBLE	= new MPI_Datatype();
MPI_UNSIGNED_CHAR	= new MPI_Datatype();
MPI_UNSIGNED_SHORT	= new MPI_Datatype();
MPI_UNSIGNED_LONG	= new MPI_Datatype();
MPI_UNSIGNED	= new MPI_Datatype();
MPI_FLOAT_INT	= new MPI_Datatype();
MPI_DOUBLE_INT	= new MPI_Datatype();
MPI_LONG_DOUBLE_INT	= new MPI_Datatype();
MPI_LONG_INT	= new MPI_Datatype();
MPI_SHORT_INT	= new MPI_Datatype();
MPI_2INT	= new MPI_Datatype();
MPI_2FLOAT	= new MPI_Datatype();
MPI_2DOUBLE	= new MPI_Datatype();
MPI_UB	= new MPI_Datatype();
MPI_LB	= new MPI_Datatype();

MPI_ERRORS_ARE_FATAL	= new MPI_Errhandler();
MPI_ERRORS_RETURN	= new MPI_Errhandler();

}
}


